"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);

// node_modules/.pnpm/tsup@6.7.0_typescript@5.0.4/node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/index.ts
var import_module = require("module");
var import_synckit = require("synckit");
var import_unist_util_visit = require("unist-util-visit");
function parseMarkingToLines(markingLines) {
  if (!markingLines)
    return [];
  return markingLines.split(" ").filter(Boolean).map((mark) => markToLines(mark)).flat(1);
}
var markToLines = (mark) => {
  const reg = /(.*)={([\d,-]+)}/;
  const match = reg.exec(mark);
  const [_, className, lineInfoStr] = Array.from(match || []);
  if (!lineInfoStr) {
    console.warn("parase markToLines error, invalid code inline marking:", mark);
    return [];
  }
  const lineList = lineInfoStr.split(",").map((v) => v.split("-").map((v2) => parseInt(v2, 10))).map(([start, end]) => {
    return end ? [...Array.from({ length: end - start + 1 }, (_2, i) => start + i)] : [start];
  }).flat(1);
  return lineList.map((line) => ({
    line,
    classes: className ? [className] : ["highlighted"]
  }));
};
var ShikiRemarkPlugin = (options) => {
  const { themes = [], theme = "nord", generateMultiCode, highlightLines, langs } = options;
  const custHighlighter = options.highlighter;
  let syncRun;
  if (!custHighlighter) {
    const require2 = (0, import_module.createRequire)(importMetaUrl);
    syncRun = (0, import_synckit.createSyncFn)(require2.resolve("./worker"));
    syncRun("getHighlighter", { langs, themes, theme });
  }
  function highlight(code, theme2, lang, lineOptions) {
    if (custHighlighter) {
      return custHighlighter.codeToHtml(code, { lang, theme: theme2, lineOptions });
    } else {
      return syncRun("codeToHtml", {
        code,
        theme: theme2,
        lang,
        lineOptions
      });
    }
  }
  return function(tree) {
    (0, import_unist_util_visit.visit)(tree, "code", visitor);
    function visitor(node) {
      let highlightHTML;
      const lineOptions = highlightLines && node.meta ? parseMarkingToLines(node.meta) : [];
      if (generateMultiCode) {
        const allHighlighted = themes.map((theme2) => {
          return highlight(node.value, theme2, node.lang || "text", lineOptions);
        });
        highlightHTML = `<div class="shiki-container">${allHighlighted.join("")}</div>`;
      } else {
        highlightHTML = highlight(node.value, theme, node.lang || "text", lineOptions);
      }
      node.type = "html";
      node.value = highlightHTML;
    }
  };
};
var src_default = ShikiRemarkPlugin;
